package asyncronous;

import javax.xml.messaging.*;
import javax.xml.soap.*;
import com.sun.xml.messaging.soaprp.*;

public class AsyncSimpleSender {
  public static void main(String[] args) {
    try {
      // ftHg̃bZ[WOvoC_Ƃ̐ڑm
      ProviderConnectionFactory pcFactory = ProviderConnectionFactory.newInstance();
      ProviderConnection pConnection = pcFactory.createConnection();
      // ڑbZ[WOvoC_̎擾
      ProviderMetaData pmData = pConnection.getMetaData();
      System.out.println("ڑbZ[WOvoC_ : " + pmData.getName());
      // SOAP-RPpbZ[Wt@Ng̐
      String[] supportedProfiles = pmData.getSupportedProfiles();
      String profile = null;
      for (int i = 0; i < supportedProfiles.length; i++) {
        if (supportedProfiles[i].equals("soaprp")) {
          profile = supportedProfiles[i];
          break;
        }
      }
      if (profile == null) {
        System.out.println("bZ[WOvoC_soaprpvt@CT|[gĂ܂");
        pConnection.close();
        System.exit(1);
      } else {
        System.out.println("pvt@C : " + profile);
      }
      MessageFactory mFactory = pConnection.createMessageFactory(profile);
      // MSOAP-RPbZ[W̍쐬iSOAPwb_j
      SOAPRPMessageImpl soaprpMsg = (SOAPRPMessageImpl)mFactory.createMessage();
      soaprpMsg.setFrom(new Endpoint("http://a.yoshida.info/"));  // olw
      soaprpMsg.setTo(new Endpoint("http://b.yoshida.info/"));  // w
      // MSOAP-RPbZ[W̍쐬iSOAP{fBj
      SOAPEnvelope envelope = soaprpMsg.getSOAPPart().getEnvelope();
      SOAPBody soapBody = envelope.getBody();
      Name bodyName = envelope.createName("name");
      SOAPBodyElement name = soapBody.addBodyElement(bodyName);
      SOAPElement firstname = name.addChildElement(envelope.createName("firstname"));
      firstname.addTextNode("Eiji");
      SOAPElement lastname = name.addChildElement(envelope.createName("lastname"));
      lastname.addTextNode("Yoshida");
      // bZ[WM
      pConnection.send(soaprpMsg);
      // RlNVؒf
      pConnection.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}