package uddiaccess;

import javax.xml.registry.*;
import javax.xml.registry.infomodel.*;
import java.util.*;

public class SimpleUDDIQuery {
  public static void main(String[] args) {
    try {
      // HTTPvLVzUDDIɃANZXƂ͈ȉݒ
      String httpProxyHost = ""; // HTTPvLVURL
      String httpProxyPort = ""; // HTTPvLV|[gԍ
      // ANZX郌WXgURLA^CviUDDIAebXMLȂǁj̎w
      Properties props = new Properties();
      props.setProperty(
        "javax.xml.registry.queryManagerURL",
        "http://www-3.ibm.com/services/uddi/v2beta/inquiryapi"); // IBM UDDIv2x[^
      props.setProperty(
        "javax.xml.registry.factoryClass",
        "com.sun.xml.registry.uddi.ConnectionFactoryImpl");
      props.setProperty("javax.xml.registry.http.proxyHost", httpProxyHost);
      props.setProperty("javax.xml.registry.http.proxyPort", httpProxyPort);
      // RlNV̐
      ConnectionFactory conFactory = ConnectionFactory.newInstance();
      conFactory.setProperties(props);
      Connection con = conFactory.createConnection();
      // WXgT[rXуNG}l[W̎擾
      RegistryService registryService = con.getRegistryService();
      BusinessQueryManager bqManager = registryService.getBusinessQueryManager();
      // rWlX𖼑OŌizCgy[Wj
      Collection findQualifiers = new ArrayList();
      findQualifiers.add(FindQualifier.SORT_BY_NAME_DESC);
      Collection namePatterns = new ArrayList();
      namePatterns.add("e"); // "e"ł͂܂rWlX
      BulkResponse bulkResponse =
        bqManager.findOrganizations(findQualifiers, namePatterns, null, null, null, null);
      // NGʕ\
      if (bulkResponse.getStatus() == JAXRResponse.STATUS_SUCCESS) {
        Collection orgs = bulkResponse.getCollection();
        System.out.println(orgs.size() + "̃rWlX܂");
        Iterator it = orgs.iterator();
        Organization org = null;
        InternationalString orgname = null , orgdesc = null;
        Key orgkey = null;
        while (it.hasNext()) {
          org = (Organization)it.next();
          orgname = org.getName();
          orgdesc = org.getDescription();
          orgkey = org.getKey();
          if (orgname != null) System.out.println("rWlX : " + orgname.getValue());
          if (orgdesc != null) System.out.println(" : " + orgdesc.getValue());
          if (orgkey != null) System.out.println("rWlXID : " + orgkey.getId());
          User contactInfo = org.getPrimaryContact();
          if (contactInfo != null) {
            PersonName personName = contactInfo.getPersonName();
            System.out.println("  A於: " + personName.getFullName());
            Collection phoneNums = contactInfo.getTelephoneNumbers(contactInfo.getType());
            Iterator phoneIt = phoneNums.iterator();
            while (phoneIt.hasNext()) {
              TelephoneNumber num = (TelephoneNumber) phoneIt.next();
              System.out.println("  dbԍ: " + num.getNumber());
            }
            Collection emailAddrs = contactInfo.getEmailAddresses();
            Iterator emailIt = emailAddrs.iterator();
            while (emailIt.hasNext()) {
              EmailAddress email = (EmailAddress)emailIt.next();
              System.out.println("  [AhX: " + email.getAddress());
            }
          }
        }
      }
      // RlNVؒf
      con.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}