import java.io.*;
import org.w3c.dom.*;
import com.sun.xml.tree.*;

public class SunParserSample {
  public static void main(String[] args) {
    try {
      // ˑiDOMIuWFNg擾j
      FileInputStream inStream 
        = new FileInputStream(args[0]);
      Document xmldoc 
        = XmlDocument.createXmlDocument(inStream, true);
      printText((Node)xmldoc);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  // ˑiDOMIuWFNgj
  static public void printText(Node node) {
    if (node.getNodeType() == Node.TEXT_NODE) {
      System.out.print(node.getNodeValue());
    }
    for (Node child = node.getFirstChild(); child != null; 
    child = child.getNextSibling()) {
      printText(child);
    }
  }
}
