package syncronous;

import javax.xml.soap.*;
import javax.xml.messaging.*;

public class SyncSimpleRequester {
  public static void main(String[] args) {
    try {
      // SOAPConnectionIuWFNg̐
      SOAPConnectionFactory scFactory = SOAPConnectionFactory.newInstance();
      SOAPConnection con = scFactory.createConnection();
      // MSOAPbZ[W̍쐬
      MessageFactory msgFactory = MessageFactory.newInstance();
      SOAPMessage message = msgFactory.createMessage();
      SOAPPart soapPart = message.getSOAPPart();
      SOAPEnvelope envelope = soapPart.getEnvelope();
      SOAPHeader header = envelope.getHeader();
      SOAPBody body = envelope.getBody();
      header.detachNode();
      Name bodyName = envelope.createName("name");
      SOAPBodyElement name = body.addBodyElement(bodyName);
      SOAPElement firstname = name.addChildElement(envelope.createName("firstname"));
      firstname.addTextNode("Eiji");
      SOAPElement lastname = name.addChildElement(envelope.createName("lastname"));
      lastname.addTextNode("Yoshida");
      // bZ[WMƕԐMbZ[WM
      URLEndpoint endpoint = new URLEndpoint("http://localhost:8080/jaxmapp/receiver");
      SOAPMessage response = con.call(message, endpoint);
      // RlNVؒf
      con.close();
      // ԐMbZ[W̕\
      System.out.println("Response:");
      response.writeTo(System.out);
      System.out.println();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}