package syncronous;

import javax.xml.messaging.*;
import javax.xml.soap.*;
import javax.servlet.*;
import java.util.Iterator;

public class SyncSimpleResponderServlet extends JAXMServlet implements ReqRespListener {

  public void init(ServletConfig servletConfig) throws ServletException {
    super.init(servletConfig);
  }

  // bZ[WM̓LqiRequest/Response^j
  public SOAPMessage onMessage(SOAPMessage message) {
    System.out.println("bZ[WMI");
    try {
      // MbZ[W̕\
      System.out.println("MbZ[We: ");
      message.writeTo(System.out);
      System.out.println();
      // MbZ[W̃f[^o
      SOAPEnvelope soapEnv = message.getSOAPPart().getEnvelope();
      SOAPBody soapBody = soapEnv.getBody();
      Iterator it = soapBody.getChildElements();
      SOAPBodyElement soapBodyElement = (SOAPBodyElement)it.next();
      Iterator cit = soapBodyElement.getChildElements();
      SOAPElement firstname = (SOAPElement)cit.next();
      SOAPElement lastname = (SOAPElement)cit.next();
      // ԐMbZ[W̍쐬
      MessageFactory msgFactory = MessageFactory.newInstance();
      SOAPMessage resMsg = msgFactory.createMessage();
      SOAPEnvelope resEnv = resMsg.getSOAPPart().getEnvelope();
      resEnv.getBody().addChildElement(resEnv.createName("Response"))
        .addTextNode("Hello! " + firstname.getValue() + " " + lastname.getValue());
      System.out.println("ԐMbZ[We: ");
      resMsg.writeTo(System.out);
      System.out.println();
      return resMsg;
    } catch(Exception e) {
      e.printStackTrace();
      return null;
    }
  }
}